/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package edu.isi.ant.yamlseranddeser;

import java.util.List;
import java.io.Serializable;
import java.util.Collections;


public class Stage implements Serializable
{
        public static enum ABSTRACTION
    {
        BLOCK_STREAMING,
        WINDOWED_STREAMING,
        STATEFUL_STREAMING
    }
    //static final long serialVersionUID = 1L;
    public Stage(List<String> input, List<String> program, List<String> output, Window window, int maxConcurrentJobs, ABSTRACTION abs)
    {
        this.input = input;
        this.program = program;
        this.output = output;
        this.window = window;
        this.maxConcurrentWorkers = maxConcurrentJobs;
        this.abstraction = abs;
        
    }

    public List<String> getInput() {
        return input;
    }

    public List<String> getProgram() {
        return program;
    }

    public List<String> getOutput() {
        return output;
    }
    
    public Window getWindow() {
        return window;
    } 
    
    public ABSTRACTION getAbstraction() {
    return this.abstraction;
    }
    
    public int getMaxConcurrentJobs() {
    return maxConcurrentWorkers;
    } 
    
    public String getCmdInput() {
        StringBuilder sb = new StringBuilder();

        for (String s : this.input) {
            sb.append(String.format(" %s %s ", "-i", s));
        }
        return sb.toString();
    }

    public String getCmdProgram() {
        StringBuilder sb = new StringBuilder();

        for (String s : this.program) {
            sb.append(String.format(" %s %s ", "-p", s));
        }
        return sb.toString();
    }

    public String getCmdOutput() {
        StringBuilder sb = new StringBuilder();

        for (String s : this.output) {
            sb.append(String.format(" %s %s ", "-o", s));
        }
        return sb.toString();
    }
    
    public String toString()
    {
        StringBuilder result = new StringBuilder();
        
        
        //input
        if(this.input != null)
        {
            result.append("Input: ");
            Collections.sort(this.input);
            for(String element:this.input) result.append(element);
        }
        
        result.append("\n");
        
        
        //program
        if(this.program != null)
        {
            result.append("Program: ");
            Collections.sort(this.program);
            for(String element:this.program) result.append(element);
        }
        
        result.append("\n");
        
        
        //output
        if(this.output != null)
        {
            result.append("Output: ");
            Collections.sort(this.output);
            for(String element:this.output) result.append(element);
        }
        
        result.append("\n");
        
        
        //max_concurrent_jobs
        if(this.maxConcurrentWorkers != 0)
        {
            result.append("max_concurrent_jobs: ");
            result.append(this.maxConcurrentWorkers);
            result.append("\n");
        }
        
        //window
        if(this.window != null)
        {
            result.append("Window: ");
            result.append(window.toString());
            result.append("\n");
        }
        
        //abstraction
        result.append("Abstraction In Use: ");
        result.append(this.abstraction.name());
        result.append("\n");
        
        return result.toString();        
        
    }
    
    public boolean isThisStageHasWindow()
    {
        return (this.window != null)?true:false;
    }
    
    private List<String> input;
    private List<String> program;
    private List<String> output;
    private Window window;
    private int maxConcurrentWorkers; // 0 means no limit of workers
    private ABSTRACTION abstraction;

}
