/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package edu.isi.ant.yamlseranddeser;

import com.esotericsoftware.yamlbeans.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author aqadeer
 */
public class YAMLSerAndDeSer {
    
    private Map<String, Stage> cumulativeJob = new HashMap<String, Stage>();
    private boolean dispTableProcessed = false;
    
    /**
     * @param args the command line arguments
     * @throws java.io.FileNotFoundException
     * @throws com.esotericsoftware.yamlbeans.YamlException
     */
    public static void main(String[] args) throws FileNotFoundException, YamlException, IOException, WindowParsingFailedException, InputQueueParsingFailedException  {  
        
        //YAMLSerAndDeSer.testDuplicateProcessingRemoval();
        YAMLSerAndDeSer.testSimpleFunctionality();
       
        
    }
    
    public static void testYAMLWriting() throws IOException
    {
        List<String> list = new ArrayList<String>();
        list.add("/user/aqadeer/f/20200901-041342-00120319.sin.rssacint");
        list.add("/user/aqadeer/f/20200901-042854-00120330.sin.rssacint");
        list.add("/user/aqadeer/f/20200901-043728-00120336.sin.rssacint");
        list.add("/user/aqadeer/f/20200901-044012-00120338.sin.rssacint");
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("section_count", 1);
        map.put("input_rssacint", list);
        boolean result = YAMLSerAndDeSer.writeYAMLFile(map, "/tmp/text.yaml");
        System.out.println("Result of YAML writing is: " + result);
    }
    
    public static void testSimpleFunctionality() throws IOException, WindowParsingFailedException, InputQueueParsingFailedException
    {
        String YAMLFile = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/JobServer/ParseYAMLFile/pipeline.yaml";
        String YAMLOutFile = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/JobServer/ParseYAMLFile/pipeline_out.yaml";
        String dotOutFile = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/JobServer/ParseYAMLFile/pipeline_out.dot";
        String graphVizOutFile = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/JobServer/ParseYAMLFile/pipeline_out.png";
        YAMLSerAndDeSer obj = new YAMLSerAndDeSer();
        obj.readYAMLFile(YAMLFile);
        obj.writeYAMLFile(YAMLOutFile);

        obj.makeDotGraph("visualize", dotOutFile, graphVizOutFile);
        
        obj.printDAG();
        Map dupTable = obj.getUniqueQueuesInSystem(true);
        obj.getDispatchTable(dupTable, true);
        System.out.println("Printing Windows");
        obj.getWindowsInSystem(true);

    }
    
    
    public static void testDuplicateProcessingRemoval() throws IOException, WindowParsingFailedException, InputQueueParsingFailedException
    {
        String u1 = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/Tez/ParseYAMLFile/u1.yaml";
        String u2 = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/Tez/ParseYAMLFile/u2.yaml";
        String u3 = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/Tez/ParseYAMLFile/u3.yaml";
        String u4 = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/Tez/ParseYAMLFile/u4.yaml";
        
        YAMLSerAndDeSer obj = new YAMLSerAndDeSer();
        obj.readYAMLFile(u1);
        obj.readYAMLFile(u2);
        obj.readYAMLFile(u3);
        obj.readYAMLFile(u4);
        
        String u1234 = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/Tez/ParseYAMLFile/u1234.yaml";
        obj.writeYAMLFile(u1234);
        
        String u1234DotOutFile = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/Tez/ParseYAMLFile/u1234.dot";
        String u1234GraphVizOutFile = "/home/aqadeer/work/antgit/ANT_GIT/CODE/BigDataProcessing/Tez/ParseYAMLFile/u1234.png";
        
        obj.makeDotGraph("visualize", u1234DotOutFile, u1234GraphVizOutFile);
        
        obj.printDAG();
        Map dupTable = obj.getUniqueQueuesInSystem(true);
        obj.getDispatchTable(dupTable, true);
        
        
    }
    
    private String getString(List<String> list)
    {
        String result = "";
        for(String s:list)
        {
            result += s;
        }
        return result;
    }
    
    
        private void processStage(Map<String,Object> stage) throws WindowParsingFailedException, InputQueueParsingFailedException
    {
        
        Stage.ABSTRACTION abs = Stage.ABSTRACTION.BLOCK_STREAMING;
        
        List<String> input = this.getValAsList(stage.get("input"));
        Collections.sort(input);
        String cumulativeInput = this.getString(input);
        if (input.contains("None"))
        {
            throw new InputQueueParsingFailedException("None is a reserved queue name and can not occur as input queue name");
        }
        
        
        List<String> program = this.getValAsList(stage.get("program"));
        Collections.sort(program);
        
        List<String> output = this.getValAsList(stage.get("output"));
        Collections.sort(output);
        String cumulativeOutput = this.getString(output);
        
        //HeadsUp: Not all stages have a window!
        Map<String,String> window = this.getValAsMap(stage.get("window"));
        if (window != null) abs = Stage.ABSTRACTION.WINDOWED_STREAMING;
        else if (stage.containsKey("abstraction") && 
                ((String)stage.get("abstraction")).toLowerCase().equals(Stage.ABSTRACTION.STATEFUL_STREAMING.name().toLowerCase()))
        {
            abs = Stage.ABSTRACTION.STATEFUL_STREAMING;
        }
        
        
        
        String key = cumulativeInput+"To"+cumulativeOutput;
        
        int maxConcurrentJobs = 0; // 0 means no restriction on no of jobs.
        if (stage.containsKey("max_concurrent_jobs"))
        {
            maxConcurrentJobs = Integer.parseInt((String)stage.get("max_concurrent_jobs"));
            if (maxConcurrentJobs <= 0 )
            {
                throw new InputQueueParsingFailedException("Value of max_concurrent_jobs should be greater than 0 and an integer.");
            }
        }
        
        //HeadsUp: if window is null, then Parser method will also return null
        Stage val = new Stage(input, program, output, Parser.parseAndEnhance(window), maxConcurrentJobs, abs);
        
        this.cumulativeJob.put(key, val);
        /* // Discontinued following because srcQ needs appropriate suffix based on no of duplicate queues.
        // Now done in getAllSystemWindows() method.
        if(val.getWindow() != null)
        {
            // for all source input queues in the stage, same windowing parameter applies
            for (String srcQ:input)
            {
                this.allWindows.put(srcQ, val.getWindow());
            }
        }
        */
        
    }
    
    
    

    
    

    
    /**
     * 
     * @param yamlFilePath 
     * Read and parse YAML file from disk
     */
    
    public boolean readYAMLFile(String yamlFilePath) throws IOException, WindowParsingFailedException, InputQueueParsingFailedException 
    {
       
        YamlReader reader;
        try {
            reader = new YamlReader(new FileReader(new File(yamlFilePath)));
        } catch (FileNotFoundException ex) {
            String err = "File not found.";
            Logger.getLogger(YAMLSerAndDeSer.class.getName()).log(Level.SEVERE, err, ex);   
            return false;
        }
        
        List<Map<String,Object>> pipeline;

        try {
            pipeline = (List<Map<String, Object>>) reader.read();
        } catch (YamlException ex) {
            String err = "YAML file not in correct format...";
            Logger.getLogger(YAMLSerAndDeSer.class.getName()).log(Level.SEVERE, err, ex);
            return false;
        }
        
        for(Map<String,Object> stage:pipeline)
        {            
            this.printIPO(stage);
            this.processStage(stage);         
            
        }
                
        
        reader.close();        
        System.out.println(this.cumulativeJob); 
        
        
        return true;
    }// end of readYAMLFile
    
    public static Map<String,Object> readYAMLFileForWindowsAbstraction(String yamlFilePath) 
                throws IOException
    {
       
        YamlReader reader;
        try {
            reader = new YamlReader(new FileReader(new File(yamlFilePath)));
        } catch (FileNotFoundException ex) {
            String err = "File not found.";
            Logger.getLogger(YAMLSerAndDeSer.class.getName()).log(Level.SEVERE, err, ex);   
            return new HashMap<String, Object>(); // ret empty map
        }
        
        Map<String,Object> yaml;

        try {
            yaml = (Map<String, Object>) reader.read();
        } catch (YamlException ex) {
            String err = "YAML file not in correct format...";
            Logger.getLogger(YAMLSerAndDeSer.class.getName()).log(Level.SEVERE, err, ex);
            return new HashMap<String, Object>(); // ret empty map
        }
        
              
        
        reader.close();        

        
        
        return yaml;
    }// end of readYAMLFile
    
    
    public boolean writeYAMLFile(String outFileName) throws IOException
    {
        
        if (null == cumulativeJob) return false;
        
        List<Map<String, Object>> list = new ArrayList<Map<String,Object>>();
        
               
       
        for (Stage stage : this.cumulativeJob.values()) {
            HashMap<String, Object> aMap = new LinkedHashMap<String, Object>();
            aMap.put("input", stage.getInput().size() > 1
                    ? stage.getInput()
                    : stage.getInput().get(0));

            aMap.put("program", stage.getProgram().size() > 1
                    ? stage.getProgram()
                    : stage.getProgram().get(0));

            aMap.put("output", stage.getOutput().size() > 1
                    ? stage.getOutput()
                    : stage.getOutput().get(0));
            if(stage.getWindow() != null)
            {
                aMap.put("window", stage.getWindow().toMap());
            }
            if(stage.getMaxConcurrentJobs() != 0)
            {
                aMap.put("max_concurrent_jobs", stage.getMaxConcurrentJobs());
            }


            list.add(aMap);

        }
        
        
        YamlWriter writer = new YamlWriter(new FileWriter(outFileName));
        // If following not done, then yamlbenas will write !java.util.LinkedHashMap in output file
        writer.getConfig().writeConfig.setWriteRootElementTags(false);
        writer.getConfig().writeConfig.setWriteRootTags(false);
        //writer.getConfig().setClassTag(" ", java.util.LinkedHashMap.class);
       
        
        writer.write(list);
        writer.close();

        
        
        return true;
    }
    
    
    public boolean makeDotGraph(String graphName, String dotOutFile, String graphVizFile) 
    {
        if (this.cumulativeJob == null) return false;
        
        try {
            PrintWriter writer = new PrintWriter(dotOutFile, "UTF-8");
            String first = String.format("strict digraph %s{", graphName);
            writer.println(first);
            
            
            
            for (Stage stage : this.cumulativeJob.values()) {
                
                List<String> input = stage.getInput();
                List<String> program = stage.getProgram();
                List<String> output = stage.getOutput();
                
                
                String prog = this.getString(program);
                
                for(String in:input)
                {
                    for(String out:output)
                    {
                                                
                        String toWrite = (stage.getWindow() == null)?String.format(
                        "\"%s\" -> \"%s\"     [label=\"%s\"] " , in,out, prog):
                        String.format("\"%s\" -> \"%s\"     [label=\"[Window] %s\",color=red] " , in,out, prog);
                        
                        writer.println(toWrite);
                        
                    }
                }
            }

            String last = "}";
            writer.println(last);

            writer.close();
            
            
            // Make a png as well
            String cmd[] = {"/usr/bin/dot",  "-Tpng", dotOutFile, "-o", graphVizFile};
            
            System.out.println(Arrays.toString(cmd));

            
            ProcessBuilder pb = new ProcessBuilder(cmd);
            Process p = pb.start();
            p.waitFor();
            int t = p.exitValue();
            System.out.println("Code = " + t);
            if ( 0 != p.exitValue()) return false;
            p.destroy();
            
            

        } catch (IOException | InterruptedException e ) {
            e.printStackTrace();
            return false;
        }


        
        return true;        
    }
    
    
   
    
    
    
    private void printIPO(Map<String, Object> stage) {
        Object inputObj = stage.get("input");
        Object programObj = stage.get("program");
        Object outputObj = stage.get("output");
        Object windowObj = stage.get("window");
        Object maxWorkerObj = stage.get("max_concurrent_jobs");

        String input = this.getKey(inputObj);
        String program = this.getKey(programObj);
        String output = this.getKey(outputObj);
        String window = (windowObj == null)?"window is null":this.getKey(windowObj);
        String maxWorkers = (maxWorkerObj == null)?"No max_concurrent_jobs given":this.getKey(maxWorkerObj);
       

        String result = String.format("%s\n%s\n%s\n%s\n%s\n", input, program, output, window, maxWorkers);

        System.out.print(result);

    }
    
    
    private void printDAG()
    {       
        this.printDAG(this.cumulativeJob);       
    }
    
    private void printDAG_Old(Map<String, Stage> pipeline){        
        
        
        for(String nodeID:pipeline.keySet())
        {
            System.out.println("*****");
            Stage stage = pipeline.get(nodeID);
            String input = this.getKey(stage.getInput());
            String program = this.getKey(stage.getProgram());
            String output = this.getKey(stage.getOutput());
            System.out.println("NodeID: " + nodeID);
            System.out.println("Input: " + input);
            System.out.println("Program: " + program);
            System.out.println("Output: " + output);
            System.out.println("*****");
        }
        
                
    }
    
    private void printDAG(Map<String, Stage> pipeline){        
        
        
        for(String nodeID:pipeline.keySet())
        {
            System.out.println("*****");
            System.out.println("NodeID: " + nodeID);
            Stage stage = pipeline.get(nodeID);
            System.out.print(stage.toString());
            System.out.println("*****");
        }
        
                
    }
    
    /**
     * 
     * @param print
     * @return 
     * 
     * This function returns a map, in which key is system final optimized
     * queues.  And value is that how many times it appears
     * 
     * Count 0f 0 means: No one consuming from that queue
     * Count of 1 means: 1 consumer only
     * Count > 1  means: More than 1 consumer and hence each need separate queue
     */
    
    public Map<String, Integer> getUniqueQueuesInSystem(boolean print)
    {
        Map<String, Stage> pipeline = this.cumulativeJob;
        
        Map<String,Integer> systemQueues = new HashMap<String, Integer>();
        
        for(Stage stage:pipeline.values())
        {
            for (String input:stage.getInput())
            {
                this.addToCount(systemQueues, input, 1);
            }
            
            
            for (String output:stage.getOutput())
            {
                this.addToCount(systemQueues, output, 0);
            } 
            
        }
        
        
        if(print)
        {
            for(String queue:systemQueues.keySet())
            {
                String out = String.format("Queue: %s  Count: %s", queue, systemQueues.get(queue));
                System.out.println(out);
            }
            
        }
        
        return systemQueues;
    }
    
    
    public List<String> getUniqueQueuesInSystem(Map<String, Integer> dupTable)
    {
        
        List<String> queues = new ArrayList();
        Map<String, Integer> currentStatus = new HashMap();
        
        for(String q:dupTable.keySet())
        {
            int val = dupTable.get(q);

            if (val > 1) {
                for(int i=1; i<= val; i++)
                {
                    int no = addToCount(currentStatus, q, 1);
                    String newQ = String.format("%s_%s", q, no);
                    queues.add(newQ);
                    
                }

            }
            else
            {
                queues.add(q);
            }
        }
        
        return queues;        
    }
    
    
    public Map<String, Window> getWindowsInSystem(boolean print)
    {
        Map<String, Window> allWindows = new HashMap<String, Window>();
        Map<String, Integer> currentStatus = new HashMap();
        Map<String,Integer> dupCount = this.getUniqueQueuesInSystem(false);
        //Heads Up: Following is a shallow copy.
        Map<String, Stage> dispatchTable = new HashMap(this.cumulativeJob);
        
        for(Stage stage:dispatchTable.values())
        {
            if(!stage.isThisStageHasWindow()) continue;
            // walk the input list
            List<String> inputs = stage.getInput();
            for(int i=0; i<inputs.size(); i++)
            {
                String key = inputs.get(i);
                if(dupCount.get(key) > 1)
                {
                    int no = addToCount(currentStatus, key, 1);
                    String newKey = String.format("%s_%s", key,no);
                    allWindows.put(newKey, stage.getWindow());
                }
                else
                {
                    allWindows.put(key, stage.getWindow());
                }
            }

        }
        if (print)
        {
            for (String key:allWindows.keySet())
            {
                System.out.println("SSSSSSSSSSSSSSSSSSS");
                System.out.println("window key = " + key);
                System.out.println(allWindows.get(key));
                System.out.println("EEEEEEEEEEEEEEEEEEE");
            }
        }
        return allWindows;
    }
    
    
    
    private int addToCount(Map<String, Integer> aMap, String key, int toAdd)
    {
        int result = 0;
        if(aMap != null)
        {
            Integer count = aMap.get(key);
            result = (count == null?toAdd:count+toAdd);
            aMap.put(key, result);
        }
        return result;
    }
    
    
    public Map<String, Stage> getDispatchTable(Map<String, Integer> dupCount, boolean print)
    {
        if (this.dispTableProcessed) return this.cumulativeJob;
        
        Map<String, Integer> currentStatus = new HashMap();
        
        // HEADS UP: Following was a shallow copy.
        Map<String, Stage> dispatchTable = new HashMap(this.cumulativeJob);
                
        for(Stage stage:dispatchTable.values())
        {
            // walk the input list
            List<String> inputs = stage.getInput();
            for(int i=0; i<inputs.size(); i++)
            {
                String key = inputs.get(i);
                if(dupCount.get(key) > 1)
                {
                    int no = addToCount(currentStatus, key, 1);
                    String newKey = String.format("%s_%s", key,no);
                    inputs.set(i, newKey);                    
                }
                
            }
 
            
        }
        this.dispTableProcessed = true;
        
        if(print)
        {
            this.printDAG(dispatchTable);            
        }
        
        return dispatchTable;
        
    }
    
    
    
    private String getKey(Object obj)
    {
        String result = "";
        
        if(obj instanceof String) result = (String)obj;
        else if (obj instanceof List)
        {
            List<String> list = (List<String>)obj;
            Collections.sort(list);
            for(String element:list) result += element;
        }
        else if (obj instanceof Map)
        {
            Map<String,String> map = (Map<String,String>)obj;
            result = new PrettyPrintingMap<String, String>(map).toString();
        }
        else if (obj instanceof Window)
        {
            result = ((Window)obj).toString();
        }
        
        return result;
    }
    
    
    private List<String> getValAsList(Object obj)
    {
        List<String> result = new ArrayList<String>();
        
        if(obj instanceof String) result.add((String)obj);
        else if (obj instanceof List) result = (List<String>)obj;
 
     
        
        return result;
    }
    
    private Map<String,String> getValAsMap(Object obj)
    {
        return (Map<String,String>)obj;
    }
    
    
    // Given a list of strings, output YAML encoded List of Strings
    public static boolean writeYAMLFile(java.util.List<String> list, 
                                        String outFileName) throws IOException
    {        
        if (null == list) return false;
        
        YamlWriter writer = new YamlWriter(new FileWriter(outFileName));
        // If following not done, then yamlbenas will write !java.util.LinkedHashMap in output file
        writer.getConfig().writeConfig.setWriteRootElementTags(false);
        writer.getConfig().writeConfig.setWriteRootTags(false);
       
        writer.write(list);
        writer.close();       
        
        return true;
    }

    // Given some Java object, let yamlBeans put it in YAML file
    public static boolean writeYAMLFile(Object obj,
                                        String outFileName) throws IOException
    {
        if (null == obj) return false;

        YamlWriter writer = new YamlWriter(new FileWriter(outFileName));
        // If following not done, then yamlbenas will write !java.util.LinkedHashMap in output file
        writer.getConfig().writeConfig.setWriteRootElementTags(false);
        writer.getConfig().writeConfig.setWriteRootTags(false);

        writer.write(obj);
        writer.close();

        return true;
    }
}


/*
What was tested?
(1) //ToDo: When tested why parsing happens twice?
Ansere: Fixed.  Was a bug.  Read yaml file function was called twice from
        the test funcition.

(2) Fixed.  It was a bug.  Now printing is improved because Stage is asked
    to print itself (that inturns asks window to print itself (if it exists)).
    2020-04-08

(3) //Bug: In yaml output file, windows are not being printed
    Fixed. 2020-04-08


(4) //ToDo: Put some special marker / color for windowed input
   Done.  Now windowed input lines will be red in color and will have "[Window]"
   written ahead of program name.

(5) //ToDo: For easy access keep all windows as a map from stage identifying string to Window
   Done.


*/
