#!/bin/bash -e

#this script re-creates virtual environment for running HLED

usage() {
    cat <<EOF
$0: create python virtual environment for running HLED

USAGE:
    $0 [PATH]

where [PATH] is the path to the installed virtual env.  Defaults to ./venv.
EOF
}

[ $# -gt 1 ] && { usage; exit 1; }
if [ $# == 1 ]; then
    case $1 in
        ( -h | --help ) usage; exit 0;
        ;;
    esac
fi

VENV_PATH=${1:-venv}

D=$(cd $(dirname $0); pwd -P)

P3=$VENV_PATH/bin/pip3
[ -e $P3 ] ||
    python3 -m venv $VENV_PATH


#$P3 install --upgrade pip
$P3 install wheel
$P3 install -r $D/requirements.txt

echo "Virtual environment successfully created under $VENV_PATH"
