#!/bin/bash
# Docker script to make MySQL db for hard link emulation work.
set -e

# Edit the following three values to your liking:
##MYSQL_USER="lander_user@%.isi.edu"
MYSQL_DATABASE="lander_ps_db"
MYSQL_CONTAINER_NAME="hard-link-emulation-mysql"


MYSQL_ROOT_PASSWORD="aqroot123"  ##$(cat /dev/urandom | LC_CTYPE=C tr -dc 'a-zA-Z0-9' | fold -w 32 | sed 1q)

echo "Start the Oracle MySQL container:"
# This initial provisioning can take up to 30 seconds.

docker \
  run \
  --detach \
  --env MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD} \
  --env MYSQL_DATABASE=${MYSQL_DATABASE} \
  --name ${MYSQL_CONTAINER_NAME} \
  --publish 3306:3306 \
  mysql:5.7;

echo "Sleeping for 10 seconds to allow time for the DB to be provisioned:"
for i in `seq 1 10`;
do
  echo "."
  sleep 1
done

echo "Database '${MYSQL_DATABASE}' running."
