#!/usr/bin/env python3



import MySQLdb
import os
import sys


from top.conf import sysConfInfo
from top.sup import db
from top.sup import hdfs


#................. Global Constants ................................................

# Default sub-dir nams inside HDFS_BASE
sub_dirs = sysConfInfo.sub_dirs


# Following done do that I dont have to write sysConfInfo every time.
Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB

#...................................................................................


#....................................................................................
def api_recordSysBaseHDFSDir(hdfsURI):


    retVal = 0
    # Make required sub-dirs in HDFS_Base

    result = hdfs.makeHDFSDirIfDoesNotExist(hdfsURI)
             

    if result != 0:
        return 1

    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 2
    
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 3

    
    retVal = db.__populateKeyValTable(dbcon, cur, "HDFS_Base_Dir", hdfsURI)
    
       

    cur.close()
    db.__disconnectFromDB(dbcon)

    


    return retVal
#....................................................................................

def api_recordQueueTypeGroups(queueType, groupName):

    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 2

    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 3


    retVal = db.__populateKeyValTable(dbcon, cur, queueType, groupName)



    cur.close()
    db.__disconnectFromDB(dbcon)

    
    return retVal
#....................................................................................
def sysInit():
    retVal = api_recordSysBaseHDFSDir(sysConfInfo.HDFS_URI)
    if retVal != 0:
        sys.stderr.write("Failed in function api_recordSysBaseHDFSDir\n");
        return (retVal)

    retVal = 0

    for key in sysConfInfo.QueueType_To_LinuxGroups_Mapping:
        retVal +=  api_recordQueueTypeGroups(key, sysConfInfo.QueueType_To_LinuxGroups_Mapping[key])

    if retVal != 0:
        sys.stderr.write("Failed in function api_recordQueueTypeGroups\n");
        return retVal


#....................................................................................

# Testing functions
if __name__ == '__main__':
    sysInit()

