#!/usr/bin/env python3



import MySQLdb
import os
import sys


from top.conf import sysConfInfo
from top.sup import db
from top.sup import hdfs


#................. Global Constants ................................................

# Default sub-dir nams inside HDFS_BASE
sub_dirs = sysConfInfo.sub_dirs


# Following done do that I dont have to write sysConfInfo every time.
Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB

       
#....................................................................................
def api_prepareHDFSDir(data_type, groupName):
    # Make appropriate directories with appropriate rights in HDFS
    
    result = 0
    
    hdfsURI = "%s/%s/" % (sysConfInfo.HDFS_URI, data_type)
    result += hdfs.makeHDFSDirIfDoesNotExist(hdfsURI)
    result += hdfs.setFileOrDirRights(hdfsURI, sysConfInfo.DirRights)
    result += hdfs.setFileOrDirGroup(hdfsURI, groupName)



    return result
#....................................................................................

# Testing functions
if __name__ == '__main__':
    print ("Write your test code here.")
    

