#!/usr/bin/env python3

import random
import sys

from top.sup import opsys, db, hdfs
from top.conf import sysConfInfo



# clean up function is meant to be run by a privileged system admin user

Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB



def doGarbageCollection():    
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        print ("Failed to get db connecton.")
        return 1
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        print ("Failed to get db cursor.")
        return 2
    
    isSuccess, dataURIs = db.__getFileListFromDataTable(dbcon, cur)
    if isSuccess != 0:
        print ("Failed to get data URIs from Data db table.")
        return 3
    
    for dataURI in dataURIs:
        if db.__deleteRowFromDataTable(dbcon, cur, dataURI, False) == 0:
            if hdfs.delHDFSFile(dataURI)  == 0:
                dbcon.commit()
                print ("Successfully delted file %s from db Data table and from HDFS." %(dataURI))
            else:
                print ("Failed to delete file from HDFS.  File is: %s.  This failure is in %s:" %(dataURI, __name__))
                dbcon.rollback()
        else:
                print ("Failed to delete file %s from DB Data table.  This failure is in %s:" %(dataURI, __name__))




    cur.close()
    db.__disconnectFromDB(dbcon)

    return 0
#..........................................................................
if __name__ == '__main__':

    doGarbageCollection()
