#!/usr/bin/env python3

import random
import sys

from top.sup import opsys, db, hdfs
from top.conf import sysConfInfo


Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


debug = False

def lander_queue_du_Inner(queue_id, queue_owner):

    byteCount = 0
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), byteCount
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquistion failed inside %s" %(__name__), byteCount

    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s doesn't exist. This failure is in %s" %(queue_id, __name__), byteCount


    # Confim queue_owner is truely owner of queue
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, queue_id, __name__), byteCount


    retCode, fileArray = db.__getFileListFromSubscriberQueue(dbcon, cur, queue_owner, queue_id)
    if retCode !=0:
        return 5, "db.__getFileListFromSubscriberQueue failed. This failure is in %s" %(__name__), byteCount



    for f in fileArray:
        retCode, noOfBytes = hdfs.getHDFSFileSizeInBytes(f)
        if retCode != 0: return 5, "hdfs.getHDFSFileSizeInBytes fialed on file: %s. This failure is in %s" %(f, __name__), byteCount
        else: byteCount += int(noOfBytes)



    cur.close()
    db.__disconnectFromDB(dbcon)

    return 0, "OK", byteCount
#..........................................................................
def lander_queue_du(queue_id, queue_owner):
    retVal, retMessage, byteCount = lander_queue_du_Inner(queue_id, queue_owner)

    print (retVal)
    print (retMessage)
    print (byteCount)

    return retVal, retMessage, byteCount

#..........................................................................
