#!/usr/bin/env python3

import random
import sys

from top.sup import opsys, db, hdfs
from top.conf import sysConfInfo


Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


debug = False

def lander_queue_queue2user_Inner(queue_id, queue_owner):

    userID = ""
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), userID
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquistion failed inside %s" %(__name__), userID

    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s doesn't exist. This failure is in %s" %(queue_id, __name__), userID


    # ToFix: For the time being any user can ask who is the owner of a queue.  Changed by aqadeer on: 2019-02-26
    # Confim queue_owner is truely owner of queue
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    #if retCode != 0 or queue_owner != queue_owner_fromDB:
    if retCode != 0:
        return 4, "Failed to find owner of queue %s. This failure is in %s" %(queue_id, __name__), userID


    cur.close()
    db.__disconnectFromDB(dbcon)

    return 0, "OK", queue_owner_fromDB
#..........................................................................
def lander_queue_queue2user(queue_id, queue_owner):
    retVal, retMessage, user = lander_queue_queue2user_Inner(queue_id, queue_owner)

    print (retVal)
    print (retMessage)
    print (user)

    return retVal, retMessage, user

#..........................................................................
