#!/usr/bin/env python3

import random
import sys

from top.sup import opsys, db, hdfs
from top.conf import sysConfInfo
from top.queue_admin import lander_queue_du as lqd


Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


debug = False

def lander_queue_user_du_Inner(queue_owner):

    byteCount = 0
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), byteCount
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquistion failed inside %s" %(__name__), byteCount



    retCode, queues = db.__getQueuesByOwner(dbcon, cur, queue_owner)
    if retCode != 0:
        return 3, "db.__getQueuesByOwner failed.  This failure is inside %s" %(__name__), byteCount



    for q in queues:
        retCode, errMessage, noOfBytes = lqd.lander_queue_du(q, queue_owner)
        if retCode != 0: return 4, "lander_queue_du failed. This failure is in %s" %(__name__), byteCount
        else: byteCount += int(noOfBytes)



    cur.close()
    db.__disconnectFromDB(dbcon)

    return 0, "OK", byteCount
#..........................................................................
def lander_queue_user_du(queue_owner):
    retVal, retMessage, byteCount = lander_queue_user_du_Inner(queue_owner)

    print (retVal)
    print (retMessage)
    print (byteCount)

    return retVal, retMessage, byteCount

#..........................................................................
