#!/usr/bin/env python3

import random
import sys
import os

from top.sup import opsys, db
from top.conf import sysConfInfo, syssetup




Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


debug = False

def listDerivedQueues(from_queue_id, queue_owner):
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), None
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquistion failed inside %s" %(__name__), None

    if db.__doesQueueExists(dbcon, cur, from_queue_id) != 0:
        return 3, "queue with id %s doesn't exist. This failure is in %s" %(from_queue_id, __name__), None


    # Confim queue_owner is truely owner of queue
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, from_queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, from_queue_id, __name__), None



    (isSuccess, queues) = db.__findDerivedQueues(dbcon, cur, from_queue_id)

    if isSuccess != 0:
        return isSuccess, "db.__findDerivedQueues failed. This failure is in %s" %(__name__), None

    if debug: print (queues)

    '''
    # Earlier we used to return only active queues

    enabledQueues = []
    key = "isActive"

    for queue_id_row in queues:
        isSuccess, isActive = db.__getValFromSubscriberKeyValTable(dbcon, cur, queue_id_row[0], key)
	if (isSuccess == 0 and isActive == "1"):
	    enabledQueues.append(queue_id_row[0])

    print ("\n".join(enabledQueues)))
    '''
    
    return 0, "OK", queues


#..........................................................................
if __name__ == '__main__':
    from_queue_id = "queue_2"
    queue_owner = "abc"

    print (listDerivedQueues(from_queue_id, queue_owner))
