#!/usr/bin/env python3

import random
import sys

from top.sup import opsys, db
from top.conf import sysConfInfo


Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


debug = False

def markAsHealthy_Inner(queue_id, file_uri, queue_owner):
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__)
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquistion failed inside %s" %(__name__)

    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s doesn't exist. This failure is in %s" %(queue_id, __name__)


    # Confim queue_owner is truely owner of queue
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, queue_id, __name__)


    retCode = db.__doesFileExistsInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, file_uri)
    if retCode !=0:
        return 5, "%s file is not in queue %s. This failure is in %s" %(file_uri, queue_id, __name__)




    
    retCode = db.__setValInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, "UNRESERVED", file_uri)
    if retCode != 0:
        return retCode , "db.__setValInSubscriberQueueTable failed. This failure is in %s" %(__name__)



    cur.close()
    db.__disconnectFromDB(dbcon)

    return retCode, "OK"
#..........................................................................
def markAsHealthy(queue_id, file_uri, queue_owner):
    retVal, retMessage = markAsHealthy_Inner(queue_id, file_uri, queue_owner)

    print (retVal)
    print (retMessage)

    return retVal, retMessage

#..........................................................................
