#!/usr/bin/env python3

import os
import sys
import calendar
import time

from top.sup import  db
from top.conf import sysConfInfo


Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB



debug = False
#..........................................................................
def lander_queue_file_older_Inner(queue_id, hdfs_file_uri, ageseconds, queue_owner):
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__)
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquisition failed inside %s" %(__name__)


    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s does not exist.  This failure is in %s" %(queue_id, __name__)


    # Confim queue_owner is truely owner of queue_id
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, queue_id, __name__)


    retCode = db.__doesFileExistsInSubscriberQueueTable(dbcon, cur, queue_id,queue_owner, hdfs_file_uri)
    if retCode != 0:
        return 5, "%s does not exist in queue %s. This failure is in %s" %(hdfs_file_uri, queue_id, __name__)

    
        
    isSuccess, modEpoch = db.__getModTimeForFileInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, hdfs_file_uri)
    
    cur.close()
    db.__disconnectFromDB(dbcon) 

    if isSuccess != 0:
        return 5, "db.__getModTimeForFileInSubscriberQueueTable failed. This failure is in %s" %(__name__)


    result = 0
    if debug: print ("Current Epoch = %s modEpoch = %s and agesecond = %s" %(str(calendar.timegm(time.gmtime())), str(modEpoch), str(ageseconds)))
    print ("Current Epoch = %s modEpoch = %s and agesecond = %s" %(str(calendar.timegm(time.gmtime())), str(modEpoch), str(ageseconds)))
    if isSuccess == 0 and (calendar.timegm(time.gmtime()) > modEpoch + int(ageseconds)):
        result = 1
    
    return result, "OK"

#..........................................................................
def lander_queue_file_older(queue_id, hdfs_file_uri, ageseconds, queue_owner):
    retVal, errMessage = lander_queue_file_older_Inner(queue_id, hdfs_file_uri, ageseconds, queue_owner)
    print (retVal)
    return retVal, errMessage

#..........................................................................


