#!/usr/bin/env python3

import os
import sys


from top.sup import  db
from top.conf import sysConfInfo



Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


#..........................................................................
def lander_queue_files(queue_id, queue_owner):

    files = []
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), files
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquisition failed inside %s" %(__name__), files


    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s does not exist.  This failure is in %s" %(queue_id, __name__), files


    # Confim queue_owner is truely owner of queue_id
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, queue_id, __name__), files

   


    state = "UNRESERVED"    
    isSuccess, files = db.__getFileListFromSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, state)
    
    cur.close()
    db.__disconnectFromDB(dbcon) 
    
    # Followin check is necessary else when queue is empty, an empty row is printed
    if len(files) > 0:
        print ("\n".join(files))

    if isSuccess != 0: return isSuccess, " db.__getFileListFromSubscriberQueueTable failed.  This failure is in %s" %(__name__), files
    else: return isSuccess, "OK", files

#..........................................................................



