#!/usr/bin/env python3

import os
import sys


from top.sup import  db, hdfs
from top.conf import sysConfInfo
from top.queue_pull import onDemand_cleanUp


Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


debug = True
#..........................................................................
def lander_queue_release_unconditional_Inner(queue_id, file_uri, queue_owner):
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return (1, "dbcon failed inside %s" %(__name__))
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return (2, "cursor acquisition failed inside %s" %(__name__))

    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return (3, "queue with id %s does not exist.  This failure is in %s" 
                     %(queue_id, __name__))

    # Confim queue_owner is truely owner of queue_id
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return (4, "%s is not owner of queue %s. This failure is in %s" 
                     %(queue_owner, queue_id, __name__))

    # There is a bug in followind db function. See comment in db.py file
    (retCode, fileHdfsURI, errorMessage) = db.__getHdfsURI(dbcon, cur, queue_id, file_uri)
    if retCode != 0:
        return (5, errorMessage)

    # make sure file exits in queue
    retCode = db.__doesFileExistsInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, fileHdfsURI)
    if retCode != 0:
        return (6, "File %s (%s) is not present in queue %s. This failure is in %s" 
                     %(file_uri, fileHdfsURI, queue_id, __name__))

    retCode  = db.__deleteFileFromQueueUnConditional(dbcon, cur, queue_owner, queue_id, fileHdfsURI)



    if retCode != 0:
        return (7, "db.__deleteFileFromQueueUnConditional failed. This failure is in %s"
                     %(__name__))
  


    # lets try to delete this file from Data table and hdfs as well
    if db.__deleteRowFromDataTable(dbcon, cur, fileHdfsURI) == 0:
        retCode = hdfs.delHDFSFile(fileHdfsURI)
    else:
        return (8, "db.__deleteRowFromDataTable failed. This failure is in %s"
                     %(__name__))



    if retCode != 0:
        return (9, "hdfs.delHDFSFile failed. This failure is in %s"
                     %(__name__))


    cur.close()
    db.__disconnectFromDB(dbcon)





    return (retCode, "OK")

#..........................................................................
def lander_queue_release_unconditional(queue_id, file_uri, queue_owner):
    retVal, retMessage = lander_queue_release_unconditional_Inner(queue_id, file_uri, queue_owner)

    print(retVal, retMessage)

    return (retVal, retMessage)


#..........................................................................

if __name__ == "__main__":
    lander_queue_release_unconditional("rsscint", "/user/plumb/hle/raw/rsscint/20190202-001141-00155759.mia.rsscint", "aqadeer")
