#!/usr/bin/env python3

import os
import sys


from top.sup import  db, hdfs
from top.conf import sysConfInfo


Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


debug = False
#..........................................................................
# return (errCode, errMessage, hdfsfileuri)
#

def lander_queue_reserve_top_Inner(queue_id, localtmp, queue_owner):

    fileName = ""
   
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), fileName
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquisition failed inside %s" %(__name__), fileName


    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s does not exist.  This failure is in %s" %(queue_id, __name__), fileName


    # Confim queue_owner is truely owner of queue_id
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, queue_id, __name__), fileName



      
    isSuccess, hdfsURI = db.__findUnreservedURIWithOldestModTimeInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner)
    if isSuccess != 0:
        return 5, "db.__findUnreservedURIWithOldestModTimeInSubscriberQueueTable failed. This failure is in %s"  %(__name__), fileName
        

    isSuccess = db.__doAtomicReserveInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, hdfsURI)
    if isSuccess != 0:
        return 6, "__doAtomicReserveInSubscriberQueueTable failed.  This failure is in %s" %(__name__) , fileName



    
    cur.close()
    db.__disconnectFromDB(dbcon) 

    
    return isSuccess, "OK", hdfsURI

#..........................................................................
def lander_queue_reserve_top(queue_id, localtmp, queue_owner):
    retVal, errMessage, hdfsURI = lander_queue_reserve_top_Inner(queue_id, localtmp, queue_owner)
    print (retVal)
    print (errMessage)
    print (hdfsURI)

    return retVal, errMessage, hdfsURI

#..........................................................................
if __name__ == '__main__':
    queue_id  = "queue_2"
    hdfs_file_uri = "hdfs://hcpu050.ant.isi.edu:9000/user/aqadeer/db2//raw/20141117-041326-00358331.erf.sz"
    localtmp = "/tmp/"
    

    result = lander_queue_reserve_top(queue_id, localtmp)
    
    print (result)


