#!/usr/bin/env python3

import os
import sys


from top.sup import  db
from top.conf import sysConfInfo




Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB

debug = False

#..........................................................................
# returns (errCode, errMessage, size)

def lander_queue_size_Inner(queue_id, queue_owner):
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), 0
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquisition failed inside %s" %(__name__), 0


    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s does not exist.  This failure is in %s" %(queue_id, __name__), 0


    # Confim queue_owner is truely owner of queue_id
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, queue_id, __name__), 0

    
    state = "UNRESERVED"    
    isSuccess, count = db.__getQueueSize(dbcon, cur, queue_id, queue_owner, state)
    
        
    cur.close()
    db.__disconnectFromDB(dbcon) 

    if isSuccess == 0: return (0, "OK", count)
    else: return (isSuccess, "db.__getQueueSize failed.  This failure is in %s" %(__name__), 0)
    

#..........................................................................
def lander_queue_size(queue_id, queue_owner):
    retVal, errMessage, size = lander_queue_size_Inner(queue_id, queue_owner)

    print (retVal)
    print (errMessage)
    print (size)

    return (retVal, errMessage, size)

#..........................................................................



