#!/usr/bin/env python3

import os
import sys

from top.sup import  db
from top.conf import sysConfInfo

Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB

debug = False
#..........................................................................
def lander_queue_unreserve_Inner(queue_id, file_uri, queue_owner):   
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return (1, "dbcon failed inside %s" %(__name__))
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return (2, "cursor acquisition failed inside %s" %(__name__))


    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return (3, "queue with id %s does not exist.  This failure is in %s" 
                     %(queue_id, __name__))


    # Confim queue_owner is truely owner of queue_id
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return (4, "%s is not owner of queue %s. This failure is in %s" 
                     %(queue_owner, queue_id, __name__))
    (retCode, fileHdfsURI, errorMessage) = db.__getHdfsURI(dbcon, cur, queue_id, file_uri)
    if retCode != 0:
        return (5, errorMessage)
    # make sure file exits in queue
    retCode = db.__doesFileExistsInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, fileHdfsURI)
    if retCode != 0:
        return (6, "File %s is not present in queue %s. This failure is in %s" 
                     %(file_uri, queue_id, __name__))

    retCode = db.__doUnreserveOperationInSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, fileHdfsURI)
    
    cur.close()
    db.__disconnectFromDB(dbcon) 

    if retCode != 0:
        return (7, "db.__doUnreserveOperationInSubscriberQueueTable failed. This failure is in %s" 
                     %(__name__))

    return retCode, "OK"

def lander_queue_unreserve(queue_id, file_uri, queue_owner):

    retVal, retMessage = lander_queue_unreserve_Inner(queue_id, file_uri, queue_owner)

    print (retVal)
    print (retMessage)

    return (retVal, retMessage)

#..........................................................................


