#!/usr/bin/env python3

import os
import sys


from top.sup import  db
from top.conf import sysConfInfo



Host =  sysConfInfo.Host
User =  sysConfInfo.User
Pass =  sysConfInfo.Pass
DB   =  sysConfInfo.DB


#..........................................................................
def listFilesInStateX(queue_id, file_state, queue_owner):

    files = []
    dbcon = db.__connectToDB(Host, User, Pass, DB)
    if dbcon == None:
        return 1, "dbcon failed inside %s" %(__name__), files
    try:
        cur = dbcon.cursor()
    except MySQLdb.Error as e:
        return 2, "cursor acquisition failed inside %s" %(__name__), files


    if db.__doesQueueExists(dbcon, cur, queue_id) != 0:
        return 3, "queue with id %s does not exist.  This failure is in %s" %(queue_id, __name__), files


    # Confim queue_owner is truely owner of queue_id
    retCode, queue_owner_fromDB = db.__getQueueOwner(dbcon, cur, queue_id)
    if retCode != 0 or queue_owner != queue_owner_fromDB:
        return 4, "%s is not owner of queue %s. This failure is in %s" %(queue_owner, queue_id, __name__), files



    retCode = db.__doesFileStateExists(dbcon, cur, file_state)
    if retCode != 0:
        return 5, "Provided file state %s is not recongnized by system. This failure is in %s" %(file_state, __name__), files

   


        
    retCode, files = db.__getFileListFromSubscriberQueueTable(dbcon, cur, queue_id, queue_owner, file_state)
    
    cur.close()
    db.__disconnectFromDB(dbcon) 
    
    print ("\n".join(files))

    if retCode != 0: return retCode, " db.__getFileListFromSubscriberQueueTable failed.  This failure is in %s" %(__name__), files
    else: return retCode, "OK", files

#..........................................................................



