#!/bin/bash

# make a named fifo and put zeek to read from there
# make a write that will be there to keep fifo open, but actually will never write to it
# (Make a function for the followng two steps because later we will need to do the same)
# get first block and write it to the zeek named fifo
# if wrired.log and notice.log are made, load them in respective queues.
# 
# in a for loop get blocks from the queue using peek
# release them if gap is 0 or negative
# strip first 24 pcap header using cat 20201122-172443-00178535.sin.pcap | tail -c +25 > ./a  and then feed to the zeek

##trap "pkill -f 'sleep 1h'" INT
##trap "set +x ; sleep 1h ; set -x" DEBUG
set -x

function finish {
  # Your cleanup code here
  exec 3>&- # close file descriptor 3
  rm forZeek
}
trap finish EXIT

mkfifo forZeek
/opt/zeek/bin/zeek -r ./forZeek ./main.zeek &
exec 3>forZeek 


# First arg: 0 or 1
# Second arg: hdfs uri
function load_file {
	if [ "$1" == 0 ]
	then
		/usr/local/bin/hdfs -cat "$2" | snzip -d -c  > forZeek
	else
		/usr/local/bin/hdfs -cat "$2" | snzip -d -c | tail -c +25 > forZeek 
	fi
}

function get_uri { 
    retCode=1	
    x=$(lander_queue_peek_next "pcap.sz_1" "hlander")
    if [ $? == 0 ]
    then
        #echo $x
        read -ra arr <<<"$x"
	if [ "${arr[1]}" == 1 ]
	then
		lander_queue_reserve_next "pcap.sz_1" "${arr[3]}" "hlander"
		retCode=$?
	fi
    fi

    echo "${arr[3]}"
    return $retCode

}

function does_work_exist {
    retCode=1  
    x=$(lander_queue_peek_next "pcap.sz_1" "hlander")
    if [ $? == 0 ] 
    then
        read -ra arr <<<"$x"
        if [ "${arr[0]}" == 1 ]
        then
                retCode=0               
        fi
    fi

    echo "$retCode"

    return $retCode

}

function wait_for_work {
	x=$(does_work_exist)

	while [ "$x" != 0 ]
	do
		sleep 30  # seconds
		x=$(does_work_exist)
	done

}

# First arg = uri
function upload_logs {
	uri="$1"
	appender=$(basename "$uri")
        appender=${appender:0:24}
        if test -f "./weird.log"; then
                ./plumb put "weird.log" "$appender.weired.log" 
        fi
        if test -f "./notice.log"; then
                ./plumb put "./notice.log" "$appender.notice.log"
        fi
	rm ./*.log

}


source call_lander_api_function_via_rpc.sh
wait_for_work
uri=$(get_uri)
if [ $? == 0 ]
then
	t1=$(date +"%s")
	load_file "0" "$uri"
	upload_logs "$uri"
	t2=$(date +"%s")
	min_interval=$(echo "($t2-$t1)/60" | bc)
	last_part=$(basename $uri)
	echo "$uri    $last_part     $t1     $t2      $min_interval" >> ./time.txt
fi



while true
do
	wait_for_work
	uri=$(get_uri)
	if [ $? == 0 ]
	then
		t1=$(date +"%s")		

        	load_file "1" "$uri"
		upload_logs "$uri"

		t2=$(date +"%s")
	        min_interval=$(echo "($t2-$t1)/60" | bc)
        	last_part=$(basename $uri)
        	echo "$uri    $last_part     $t1     $t2      $min_interval" >> ./time.txt
	fi
	exit 0
done
