#!/usr/bin/env python3

import sys

# Need to install pyyaml for the following
import yaml


def yaml_to_map(yaml_file_path):
    with open(yaml_file_path, 'r') as stream:
        try:
            return yaml.safe_load(stream)
        except yaml.YAMLError as exc:
            print(exc)


def map_to_yaml(map_data, yaml_file_path):
    with open(yaml_file_path, 'w') as stream:
        try:
            yaml.dump(map_data, stream)
        except yaml.YAMLError as exc:
            print(exc)


def stdin_yaml_to_map():
    try:
        return yaml.safe_load(sys.stdin)
    except yaml.YAMLError as exc:
        print(exc)


def map_to_stdout_yaml(map_data):
    try:
        yaml.dump(map_data, sys.stdout)
    except yaml.YAMLError as exc:
        print(exc)


if __name__ == '__main__':
    # my_map = yaml_to_map("/tmp/text.yaml")
    # map_to_yaml(my_map, "/tmp/from_python.yaml")
    my_map = stdin_yaml_to_map()
    map_to_stdout_yaml(my_map)
